"ui";
$ui.layout(
    <frame>
        <vertical bg="#F5F5F5" gravity="center">
            <vertical marginLeft="20" marginRight="20" w="auto" h="*" gravity="center"  >
                <text id="错误" text="" textSize="16" marginBottom="15" textColor="red" />
                <horizontal layout_gravity="center" >
                    <button id="刷新" w="60" h="40" textSize="14" style="Widget.AppCompat.Button.Colored" text="刷新" />
                    <text text=" $" textSize="16" textColor="#1976D2" />
                    <text text=" 余额：" textSize="16" />
                    <text id="sx" hint="请输入key并点击刷新" w="auto" singleLine="true" />
                </horizontal>
                <horizontal layout_gravity="center" marginTop="10">
                    <text text="⚙" textColor="#1976D2" textSize="16" />
                    <text text="  设置面板" textSize="16" />
                </horizontal>
                <horizontal layout_gravity="center" marginTop="10">
                    <text text="悬浮提示:" textSize="16" />
                    <checkbox id="悬浮窗" textSize="14" marginRight="20" />
                </horizontal>
                <horizontal layout_gravity="center" >
                    <text text="密钥:" textSize="16" />
                    <input id="密钥" hint="请输入密钥" textSize="16" w="250" singleLine="true" />
                </horizontal>
                <horizontal layout_gravity="center">
                    <text text="节点:" textSize="16" />
                    <input id="节点" hint="请输入节点" textSize="16" w="250" singleLine="true" />
                </horizontal>
                <horizontal layout_gravity="center">
                    <text text="点击速度:" textSize="16" />
                    <input id="点击速度" hint="建议设置为200ms" textSize="16" w="250" singleLine="true" />
                </horizontal>
                <horizontal layout_gravity="center">
                    <text text="小图等待刷新时间:" textSize="16" />
                    <input id="刷新时间" hint="建议设置为6000ms" textSize="16" w="250" singleLine="true" />
                </horizontal>
                <text id="reww" text="" w="250" />
                <button id="start" marginTop="10" w="200" gravity="center" style="Widget.AppCompat.Button.Colored" text="启动" />
            </vertical>
        </vertical>
    </frame>
);


var 线程 = 0
var 悬浮窗 = false;
var window = 0;
var 调节 = parseInt(device.width * 0.48)
$ui.reww.attr("w", 调节);
$ui.点击速度.attr("w", 调节);
$ui.节点.attr("w", 调节);
$ui.密钥.attr("w", 调节);
$ui.start.attr("w", parseInt(调节 * 0.8));
var data = storages.create("data");
if (data.get("密钥") != null){
    ui.密钥.setText(data.get("密钥"));
}
if (data.get("节点") != null){
    ui.节点.setText(data.get("节点"));
}else{
    ui.节点.setText("https://china.yescaptcha.com");
}
if (data.get("点击速度") != null){
    ui.点击速度.setText(data.get("点击速度"));
}else{
    ui.点击速度.setText("200");
}

if (data.get("刷新时间") != null){
    ui.刷新时间.setText(data.get("刷新时间"));
}else{
    ui.刷新时间.setText("6000");
}
    
if (data.get("悬浮窗") != null)
    ui.悬浮窗.setChecked(data.get("悬浮窗"));
var 密钥 = ui.密钥.getText();

if (密钥 != "") {
    ui.sx.setText("查询中...");
    setTimeout(function () {
        var 返回 = inquire_Remaining(true)
        if (返回 == "失败") {
            ui.sx.setText("获取失败...");
        } else if (返回 == "超时") {
            ui.sx.setText("获取超时...");
        } else {
            ui.sx.setText((返回).toString());
        }
    }, 200)
}
var url = ui.节点.getText() + "/createTask";
var 点击速度 = parseInt(ui.点击速度.getText())
var 刷新时间 = parseInt(ui.刷新时间.getText())

ui.悬浮窗.click(function () {
    悬浮窗 = ui.悬浮窗.isChecked();
    var data = storages.create("data");
    if (悬浮窗) {
        if (!$floaty.checkPermission()) {
            toast("请赋予悬浮窗权限");
            $floaty.requestPermission();
            exit();
        } else {
            console.log('已有悬浮窗权限');
            data.put("悬浮窗", 悬浮窗);
        }
    } else {
        data.put("悬浮窗", 悬浮窗);
    }
})


ui.刷新.click(function () {
    ui.sx.setText("查询中...");
    ui.错误.setText("")
    密钥 = ui.密钥.getText();
    if (密钥 == "") {
        ui.sx.setText("请输入密钥！");
    } else {
        setTimeout(function () {
            var 返回 = inquire_Remaining(true)
            if (返回 == "失败") {
                ui.sx.setText("获取失败...");
            } else if (返回 == "超时") {
                ui.sx.setText("获取超时...");
            } else {
                ui.sx.setText((返回).toString());
            }
        }, 200)
    }
})
ui.start.click(function () {
    if (ui.start.getText() != "停止") {
        $settings.setEnabled('foreground_service', true);
        setTimeout(function () {
            密钥 = ui.密钥.getText();
            var 节点 = ui.节点.getText();
            点击速度 = ui.点击速度.getText();
            刷新时间 = ui.刷新时间.getText();
            悬浮窗 = ui.悬浮窗.isChecked();
            if (密钥 == "") {
                ui.错误.setText("请输入密钥...")
                return
            } else if (节点 == "") {
                ui.错误.setText("请输入节点...")
                return
            } else if (点击速度 == "") {
                ui.错误.setText("请输入点击速度...")
                return
            } else if (刷新时间 == "") {
                ui.错误.setText("请输入小图等待时间...")
                return
            }
            ui.start.setText("停止");
            var data = storages.create("data");
            data.put("密钥", 密钥);
            data.put("节点", 节点);
            data.put("点击速度", 点击速度);
            data.put("刷新时间", 刷新时间);
            data.put("悬浮窗", 悬浮窗);
            threads.start(function () {
                var ser = auto.service
                if (ser == null) {
                    toastLog("请开启无障碍服务！")
                    ui.run(function () {
                        ui.错误.setText("无障碍未启动")
                        ui.start.setText("启动");
                    });
                    auto.waitFor()
                    var ser = auto.service
                    if (ser != null) {
                        ui.run(function () {
                            ui.错误.setText("")
                        });
                    }
                    ui.run(function () {
                        ui.start.setText("启动");
                    });
                    return;
                    // log(123123)
                } else {

                }

                var jtqx = $images.getScreenCaptureOptions()
                if (jtqx == null) {
                    toastLog("请赋予截图权限！")
                    requestScreenCapture()
                    sleep(1500)
                    toastLog("截图权限获取中。。")
                } else {
                    toastLog("已有截图权限")
                }
                if (悬浮窗) {
                    window = floaty.rawWindow(
                        <horizontal>
                            <text id="运行" textSize="18" text="等待中..." textColor="red" />
                        </horizontal>
                    )
                    var 位置 = parseInt(device.width * 0.1)
                    window.setTouchable(false)
                    ui.run(function () {
                        window.setPosition(0, 位置);
                    });
                }
                log("开始执行")
                var 等待 = 0
                while (true) {
                    if (等待 <= 0) {
                        等待 = 0
                        if (id("rc-imageselect").exists()) {
                            //log("验证中...")
                            if (线程 == 0) {
                                线程 = threads.start(function () {
                                    log("开始验证")
                                    if (悬浮窗) {
                                        ui.run(function () {
                                            window.运行.setText("开始验证...")
                                        });
                                    }
                                    自动验证()
                                    if (悬浮窗) {
                                        ui.run(function () {
                                            window.运行.setText("等待中...")
                                        });
                                    }
                                    log("结束验证")
                                    线程 = 0
                                    等待 = 1
                                })
                                sleep(5000)
                            }
                        } else {
                            if (id("recaptcha-anchor").exists()) {
                                if (id("recaptcha-anchor").checked(false).exists()) {
                                    if (线程 == 0) {
                                        线程 = threads.start(function () {
                                            log("开始验证")
                                            if (悬浮窗) {
                                                ui.run(function () {
                                                    window.运行.setText("开始验证...")
                                                });
                                            }
                                            自动验证()
                                            if (悬浮窗) {
                                                ui.run(function () {
                                                    window.运行.setText("等待中...")
                                                });
                                            }
                                            log("结束验证")
                                            线程 = 0
                                            等待 = 1
                                        })
                                        sleep(5000)
                                    } else {
                                        if (线程.isAlive()) {
                                            log("强制结束验证")
                                            线程.interrupt()
                                            线程.join()
                                            log("线程2是否存活：" + 线程.isAlive())
                                            if (悬浮窗) {
                                                ui.run(function () {
                                                    window.运行.setText("等待中...")
                                                });
                                            }
                                            线程 = 0
                                            等待 = 2
                                        }

                                    }
                                }
                            } else {
                                if (线程 != 0) {
                                    if (线程.isAlive()) {
                                        log("强制结束验证")
                                        线程.interrupt()
                                        线程.join()
                                        log("线程2是否存活：" + 线程.isAlive())
                                        if (悬浮窗) {
                                            ui.run(function () {
                                                window.运行.setText("等待中...")
                                            });
                                        }
                                        线程 = 0
                                        等待 = 2
                                    }
                                }
                            }
                        }
                    } else {
                        等待--
                    }
                    sleep(1000)
                }
            })
        }, 200)
    } else {
        ui.start.setText("停止中...");
        threads.shutDownAll()
        if (悬浮窗) {
            if (window!=0) {
                ui.run(function () {
                    floaty.closeAll();
                });
            }
        }
        ui.start.setText("启动");
    }
})

function 自动验证() {
    while (true) {
        try {
            if (className("android.view.View").text("reCAPTCHA").exists()) {
                log("存在")
                if (id("recaptcha-anchor").checked(false).findOne(3000) == null) {
                    log("等待控件recaptcha-anchor超时退出")
                    return
                }
                log(id("recaptcha-anchor").click())
                if (id("rc-imageselect").findOne(2000) == null) {
                    log("等待控件rc-imageselect超时退出")
                    return
                }
                var 范围 = id("rc-imageselect").findOne(2000).child(2).bounds()//得到图片的范围
                sleep(1000)
                log(范围)
                var 数量 = id("rc-imageselect").findOne(2000).child(2).childCount()//得到时几张图
                sleep(1000)
                log(数量)
                if (id("rc-imageselect").findOne().child(1).child(0).childCount() == 1) {
                    var 问题获取 = id("rc-imageselect").findOne().child(1).child(0).child(0).child(1).text()
                } else {
                    var 问题获取 = id("rc-imageselect").findOne().child(1).child(0).child(1).child(1).text()
                }
                var 最终问题 = question_T(问题获取)
                if (悬浮窗) {
                    ui.run(function () {
                        window.运行.setText("问题：" + 最终问题 + ",图数：" + 数量)
                    });
                }
                var 问题ID = problem(最终问题);
                log("问题:" + 最终问题 + "  问题ID:" + 问题ID)
                sleep(2000)
                var 截图 = captureScreen();
                var 范围2 = 范围.toString().replace(/[^0-9,-]/ig, "");
                var 分割 = 范围2.split("-")
                坐标 = 分割[0].split(",")
                坐标2 = 分割[1].split(",")
                坐标x = parseInt(坐标[0]);
                坐标y = parseInt(坐标[1]);
                宽 = parseInt(坐标2[0]) - 坐标x;
                高 = parseInt(坐标2[1]) - 坐标y;
                var clip = images.clip(截图, 坐标x, 坐标y, 宽, 高);
                if (parseInt(数量) == 9) {
                    log("压缩300*300")
                    var res = images.resize(clip, [300, 300]);
                } else {
                    log("压缩450*450")
                    var res = images.resize(clip, [450, 450]);
                }
                clip.recycle()
                var img_base64 = images.toBase64(res)
                res.recycle()
                var 已知点位 = getVerificationSum(img_base64, 问题ID, 数量)
                if (已知点位 == "跳过" || 已知点位 == "超时") {
                    log("超时或者跳过")
                    return;
                }
                sleep(1000)
                var 小图范围 = id("rc-imageselect").findOne(2000).child(2).child(已知点位[0]).bounds()//得到时几张图
                var 小图范围2 = 小图范围.toString().replace(/[^0-9,-]/ig, "");
                var 分割 = 小图范围2.split("-")
                var 小图坐标 = 分割[0].split(",")
                var 小图坐标2 = 分割[1].split(",")
                var 小图坐标x = parseInt(小图坐标[0]);
                var 小图坐标y = parseInt(小图坐标[1]);
                var 小图宽 = parseInt(小图坐标2[0]) - 小图坐标x;
                var 小图高 = parseInt(小图坐标2[1]) - 小图坐标y;
                var 截图 = captureScreen();
                var clip = images.clip(截图, 小图坐标x, 小图坐标y, 小图宽, 小图高);
                var 获取的所有点 = images.findAllPointsForColor(clip, "#1A73E8", { similarity: 0.984 })
                clip.recycle()
                if (获取的所有点.length > 1000) {
                    id("recaptcha-verify-button").click();
                    log("大图完成")
                    return "完成";
                } else {
                    if (悬浮窗) {
                        ui.run(function () {
                            window.运行.setText("小图验证..")
                        });
                    }
                    var 小图结果 = 小图验证(问题ID, 已知点位)
                    if (小图结果 == "完成") {
                        log("小图完成")
                        return "完成";
                    }
                }
            }
        } catch (error) {
            log(error)
        }
        sleep(1000)
    }
}

//获取验证码问题ID
function problem(pbm) {
    if (pbm == "出租车") {
        log("出租车")
        return "/m/0pg52";
    } else if (pbm == "巴士") {
        log("巴士")
        return "/m/01bjv";
    } else if (pbm == "校车") {
        log("校车")
        return "/m/02yvhj";
    } else if (pbm == "摩托车") {
        log("摩托车")
        return "/m/04_sv";
    } else if (pbm == "拖拉机") {
        log("拖拉机")
        return "/m/013xlm";
    } else if (pbm == "烟囱") {
        log("烟囱")
        return "/m/01jk_4";
    } else if (pbm == "人行横道") {
        log("人行横道")
        return "/m/014xcs";
    } else if (pbm == "红绿灯") {
        log("红绿灯")
        return "/m/015qff";
    } else if (pbm == "自行车") {
        log("自行车")
        return "/m/0199g";
    } else if (pbm == "停车计价表") {
        log("停车计价表")
        return "/m/015qbp";
    } else if (pbm == "汽车") {
        log("汽车")
        return "/m/0k4j";
    } else if (pbm == "桥") {
        log("桥")
        return "/m/015kr";
    } else if (pbm == "船") {
        log("船")
        return "/m/019jd";
    } else if (pbm == "棕榈树") {
        log("棕榈树")
        return "/m/0cdl1";
    } else if (pbm == "山") {
        log("山")
        return "/m/09d_r";
    } else if (pbm == "消防栓") {
        log("消防栓")
        return "/m/01pns0";
    } else if (pbm == "楼梯") {
        log("楼梯")
        return "/m/01lynh";
    } else if (pbm == "停车计价表") {
        log("停车计价表")
        return "/m/015qbp";
    } else {
        log("没有该类型")
        return null;
    }
}

function question_T(问题) {
    var arr = "";                           
    if (问题.includes("道")|| 问题.includes("crosswalks")) {//
        arr = "人行横道"
    } else if (问题.includes("租")|| 问题.includes("計程")|| 问题.includes("taxis")) {
        arr = "出租车"
    } else if (问题.includes("自")|| 问题.includes("踏")|| 问题.includes("bicycles")) {//
        arr = "自行车"
    } else if (问题.includes("栓")|| 问题.includes("hydrant")) {//
        arr = "消防栓"
    } else if (问题.includes("灯")|| 问题.includes("燈")|| 问题.includes("lights")) {//
        arr = "红绿灯"
    } else if (问题.includes("轿") || 问题.includes("动")|| 问题.includes("汽")|| 问题.includes("交通")|| 问题.includes("cars")|| 问题.includes("vehicles")) {
        arr = "汽车"
    } else if (问题.includes("公")|| 问题.includes("bus")|| 问题.includes("buses")) {//
        arr = "巴士"
    } else if (问题.includes("摩")|| 问题.includes("機車")|| 问题.includes("motorcycles")) {//
        arr = "摩托车"
    } else if (问题.includes("树")|| 问题.includes("palm")) {
        arr = "棕榈树"
    } else if (问题.includes("桥")|| 问题.includes("橋")|| 问题.includes("bridges")) {//
        arr = "桥"
    } else if (问题.includes("拉")|| 问题.includes("ractors")) {
        arr = "拖拉机"
    } else if (问题.includes("船")|| 问题.includes("boats")) {
        arr = "船"
    } else if (问题.includes("梯")|| 问题.includes("stairs")) {//
        arr = "楼梯"
    } else if (问题.includes("山")|| 问题.includes("mountains")) {//
        arr = "山"
    } else if (问题.includes("烟")|| 问题.includes("煙")|| 问题.includes("chimneys")) {//
        arr = "烟囱"
    } else if (问题.includes("计")|| 问题.includes("計價")|| 问题.includes("parking")) {//
        arr = "停车计价表"
    }
    return arr;
}
function 小图验证(最终问题, 已知点位) {
    while (true) {
        try {
            if (悬浮窗) {
                ui.run(function () {
                    window.运行.setText("待验证小图：" + 已知点位)
                });
            }
            sleep(刷新时间)
            var isShuzu = []
            var isSZbianliang = 0;
            var 截图 = captureScreen();
            for (let index = 0; index < 已知点位.length; index++) {
                var 范围 = id("rc-imageselect").findOne().child(2).child(已知点位[index]).bounds()//得到图片的范围 
                var 范围2 = 范围.toString().replace(/[^0-9,-]/ig, "");
                var 分割 = 范围2.split("-")
                坐标 = 分割[0].split(",")
                坐标2 = 分割[1].split(",")
                坐标x = parseInt(坐标[0]);
                坐标y = parseInt(坐标[1]);
                宽 = parseInt(坐标2[0]) - 坐标x;
                高 = parseInt(坐标2[1]) - 坐标y;
                var clip = images.clip(截图, 坐标x, 坐标y, 宽, 高);//裁剪图片x,y,w,h
                var res = images.resize(clip, [100, 100]);//压缩图片
                clip.recycle()
                var img_base64 = images.toBase64(res)
                res.recycle()
                var 已知点位2 = getVerificationSum(img_base64, 最终问题, null, 已知点位[index])
                if (已知点位2 != null & 已知点位2 != false & 已知点位2 != "超时") {
                    isShuzu[isSZbianliang] = 已知点位2;
                    isSZbianliang = isSZbianliang + 1;
                } else if (已知点位2 == "超时") {
                    isShuzu[isSZbianliang] = 已知点位[index];
                    isSZbianliang = isSZbianliang + 1;
                }
                sleep(500)
            }
            已知点位 = isShuzu
            if (已知点位[0] == null) {
                id("recaptcha-verify-button").click();
                return "完成";
            }
        } catch (error) {
            log(error)
        }
    }
}

function getVerificationSum(img_base64, question, quantity, 已知点位) {
    // var remaining = inquire_Remaining(false)
    // if (remaining) {
        var sum = create_Task(img_base64, question, quantity, 已知点位)
        log("返回结果" + sum)
        if (sum == "跳过") {
            return "跳过";
        } else if (sum == "超时") {
            return "超时";
        } else {
            if (悬浮窗) {
                ui.run(function () {
                    window.运行.setText("结果：" + sum)
                });
            }
            return sum;
        }
    // } else if (remaining == "失败") {
    //     toastLog("获取密钥余额失败！！")
    //     return "跳过";
    // } else {
    //     log("出去了")
    //     return "超时";
    // }
}

function Maxclick(gvXY, whether) {
    log(gvXY)
    log(whether)
    if (whether == 9) {
        log("点击九宫格")
        for (let index = 0; index < gvXY.length; index++) {
            if (gvXY[index] == 0) {
                if (id("rc-imageselect").findOne().child(2).child(0).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(0).click()) {
                }
            } else if (gvXY[index] == 1) {
                if (id("rc-imageselect").findOne().child(2).child(1).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(1).click()) {
                }
            } else if (gvXY[index] == 2) {
                if (id("rc-imageselect").findOne().child(2).child(2).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(2).click()) {
                }
            } else if (gvXY[index] == 3) {
                if (id("rc-imageselect").findOne().child(2).child(3).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(3).click()) {
                }
            } else if (gvXY[index] == 4) {
                if (id("rc-imageselect").findOne().child(2).child(4).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(4).click()) {
                }
            } else if (gvXY[index] == 5) {
                if (id("rc-imageselect").findOne().child(2).child(5).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(5).click()) {
                }
            } else if (gvXY[index] == 6) {
                if (id("rc-imageselect").findOne().child(2).child(6).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(6).click()) {
                }
            } else if (gvXY[index] == 7) {
                if (id("rc-imageselect").findOne().child(2).child(7).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(7).click()) {
                }
            } else if (gvXY[index] == 8) {
                if (id("rc-imageselect").findOne().child(2).child(8).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(8).click()) {
                }
            } else {
                log(whether + "=没有对应位置")
            }
            sleep(点击速度)
        }
    } else {
        log("点击十六宫格")
        for (let index = 0; index < gvXY.length; index++) {
            if (gvXY[index] == 0) {
                if (id("rc-imageselect").findOne().child(2).child(0).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(0).click()) {
                }
            } else if (gvXY[index] == 1) {
                if (id("rc-imageselect").findOne().child(2).child(1).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(1).click()) {
                }
            } else if (gvXY[index] == 2) {
                if (id("rc-imageselect").findOne().child(2).child(2).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(2).click()) {
                }
            } else if (gvXY[index] == 3) {
                if (id("rc-imageselect").findOne().child(2).child(3).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(3).click()) {
                }
            } else if (gvXY[index] == 4) {
                if (id("rc-imageselect").findOne().child(2).child(4).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(4).click()) {
                }
            } else if (gvXY[index] == 5) {
                if (id("rc-imageselect").findOne().child(2).child(5).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(5).click()) {
                }
            } else if (gvXY[index] == 6) {
                if (id("rc-imageselect").findOne().child(2).child(6).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(6).click()) {
                }
            } else if (gvXY[index] == 7) {
                if (id("rc-imageselect").findOne().child(2).child(7).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(7).click()) {
                }
            } else if (gvXY[index] == 8) {
                if (id("rc-imageselect").findOne().child(2).child(8).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(8).click()) {
                }
            } else if (gvXY[index] == 9) {
                if (id("rc-imageselect").findOne().child(2).child(9).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(9).click()) {
                }
            } else if (gvXY[index] == 10) {
                if (id("rc-imageselect").findOne().child(2).child(10).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(10).click()) {
                }
            } else if (gvXY[index] == 11) {
                if (id("rc-imageselect").findOne().child(2).child(11).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(11).click()) {
                }
            } else if (gvXY[index] == 12) {
                if (id("rc-imageselect").findOne().child(2).child(12).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(12).click()) {
                }
            } else if (gvXY[index] == 13) {
                if (id("rc-imageselect").findOne().child(2).child(13).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(13).click()) {
                }
            } else if (gvXY[index] == 14) {
                if (id("rc-imageselect").findOne().child(2).child(14).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(14).click()) {
                }
            } else if (gvXY[index] == 15) {
                if (id("rc-imageselect").findOne().child(2).child(15).clickCenter()) {
                } else if (id("rc-imageselect").findOne().child(2).child(15).click()) {
                }
            } else {
                log(whether + "=没有对应位置")
            }
            sleep(点击速度)
        }

    }
}

function create_Task(img_base64, question, quantity, 已知点位) {
    var task_type = "ReCaptchaV2Classification"//验证码类型
    var params = {
        "clientKey": 密钥,
        "task": {
            "type": task_type,
            "image": img_base64,
            "question": question,
        },
        "softID": 3573,
    }
    try {
        //发送JSON格式的数据
        if (悬浮窗) {
            ui.run(function () {
                window.运行.setText("请求中...")
            });
        }

        http.__okhttp__.setTimeout(20000);
        var result = http.postJson(url, data = params)
        var r = result.body.json()
        var r2 = r.solution
        log("errorId=" + r.errorId)
        log(r.errorDescription)
        if (r2.type == "multi") {
            log("objects=" + r2.objects)
            r3 = r2.objects
            if (r3[0] == null) {
                log("没有图点击跳过")
                id("recaptcha-verify-button").click();
                sleep(1000)
                return "跳过";
            } else {
                log("location")
                Maxclick(r3, quantity)//点击对应位置
                return r3;
            }
        } else {
            log("单一图=" + r2.hasObject)
            if (r2.hasObject) {
                id("rc-imageselect").findOne().child(2).child(已知点位).click()
                return 已知点位;
            } else {
                return false;
            }
        }
    } catch (e) {
        log(e)
        toastLog("验证码获取超时。。。")
        return "超时";
    }
}
//查询余额
function inquire_Remaining(查询) {
    var url = "https://api.yescaptcha.com/getBalance"//验证码平台API接口
    try {
        //发送JSON格式的数据
        if (查询 == false) {
            if (悬浮窗) {
                ui.run(function () {
                    window.运行.setText("验证余额...")
                });
            }
        }
        http.__okhttp__.setTimeout(10000);
        var result = http.post(url, { "clientKey": 密钥 })
        var r = result.body.json()
        if (r.errorId == 0) {
            ui.run(function () {
                ui.错误.setText("")
            });
            if (查询) {
                return r.balance;
            }
            if (r.balance > 1000) {
                log("余额充足：" + r.balance)
                return true;
            } else if (r.balance < 1000 & r.balance < 30) {
                toastLog("密钥余额：" + r.balance);
                return true;
            } else {
                toastLog("密钥余额不足：" + r.balance);
                return "余额不足";
            }
        } else {
            ui.run(function () {
                ui.错误.setText(r.errorDescription + ",请刷新!!!")
            });
            return "失败";
        }
    } catch (e) {
        log(e)
        toastLog("余额获取超时。。。")
        return "超时"
    }
}